;######################################################################## 
;######################################################################## 
;######################################################################## 
ANZEIGE_HAUPT:
	; ZEILE1	
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_TASTE_A*2)	; TEXT 
	ldi ZL,  low(TEXT_TASTE_A*2)
	rcall ANZEIGE_TEXT	
	; ZEILE2	
	rcall LCD_ZEILE2
	ldi ZH, high(TEXT_TASTE_B*2)	; TEXT 
	ldi ZL,  low(TEXT_TASTE_B*2)
	rcall ANZEIGE_TEXT	
	; ZEILE3	
	rcall LCD_ZEILE3
	ldi ZH, high(TEXT_TASTE_C*2)	; TEXT 
	ldi ZL,  low(TEXT_TASTE_C*2)
	rcall ANZEIGE_TEXT	
	; ZEILE4	
	rcall LCD_ZEILE4
	ldi ZH, high(TEXT_TASTE_D*2)	; TEXT 
	ldi ZL,  low(TEXT_TASTE_D*2)
	rcall ANZEIGE_TEXT	
	ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
ANZEIGE_TAKT_KURZ:
	ldi temp1,BYTE1(TAKT)
	ldi temp2,BYTE2(TAKT)
	ldi temp3,BYTE3(TAKT)
	ldi temp4,BYTE4(TAKT)
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	rcall LCD_AUSGABE_ZAHL_8_STELLEN_KURZ
	ldi temp,'H'
	rcall LCD_DATA_TEMP
	ldi temp,'z'
	rcall LCD_DATA_TEMP

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
ANZEIGE_OK_KURZ:
	ldi temp,'O'
	rcall LCD_DATA_TEMP
	ldi temp,'K'
	rjmp LCD_DATA_TEMP
;######################################################################## 
;######################################################################## 
;######################################################################## 
ANZEIGE_ERROR_ZEILE4:
	; ZEILE4	
	rcall LCD_ZEILE4
	ldi ZH, high(TEXT_ERROR*2)	; TEXT 
	ldi ZL,  low(TEXT_ERROR*2)
	rjmp ANZEIGE_TEXT
;######################################################################## 
;######################################################################## 
;######################################################################## 
ANZEIGE_ERROR_CODE:
	tst FEHLER_CODE
	brne ANZEIGE_ERROR_CODE_RUN
	ret
ANZEIGE_ERROR_CODE_RUN:
	; ZEILE1	
	rcall LCD_CLEAR	
	ldi ZH, high(TEXT_ERROR*2)	; TEXT 
	ldi ZL,  low(TEXT_ERROR*2)
	rcall ANZEIGE_TEXT
	; ZEILE2
	rcall LCD_ZEILE2
	mov temp1,FEHLER_CODE
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1		; inp: temp1
	rcall LCD_SPACE

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INP: FEHLER_CODE														  
ANZEIGE_ERROR_SCHWER:
	; ZEILE1	
	rcall LCD_CLEAR	
	ldi ZH, high(TEXT_ERROR*2)	; TEXT 
	ldi ZL,  low(TEXT_ERROR*2)
	rcall ANZEIGE_TEXT
	; ZEILE2
	rcall LCD_ZEILE2
	mov temp1,FEHLER_CODE
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1		; inp: temp1
	rcall wait_1s
	rcall wait_1s

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
ANZEIGE_WARTUNG:
	; ZEILE1	
	rcall LCD_CLEAR	
	LDS temp1,(adr_TASTE)
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1
	; ZEILE2
	rcall LCD_ZEILE2

	ldi temp1, (0<<DISP_LED)|(0<<DISP_E)|(0<<DISP_RW)|(0<<DISP_RS)|(1<<DISP_D7)|(1<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1
	; ZEILE3
	rcall LCD_ZEILE3

	; ZEILE4
	rcall LCD_ZEILE4

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
