;######################################################################## 
;######################################################################## 		
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Der Begrungstext															
ANZEIGE_BEGRUESSUNG:
	; ZEILE1	
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall ANZEIGE_TEXT
	; ZEILE2	
	rcall LCD_ZEILE2
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall ANZEIGE_TEXT
	; ZEILE3	
	rcall LCD_ZEILE3
	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT	
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	rcall ANZEIGE_TEXT
	; ZEILE4	
	rcall LCD_ZEILE4
	ldi ZH, high(TEXT_BEGRUESSUNG_4*2)	; TEXT	
	ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
	rcall ANZEIGE_TEXT
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; rcall LCD_AUSGABE_ZAHL_3_STELLEN	; inp: temp1			 	  		  
LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32
	rjmp LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
;######################################################################## 
;######################################################################## 
;######################################################################## 
; rcall LCD_AUSGABE_ZAHL_5_STELLEN	; inp: temp1 + 2		 	  		  
LCD_AUSGABE_ZAHL_5_STELLEN_TEMP1_TEMP2:
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32
	rjmp LCD_AUSGABE_ZAHL_5_STELLEN_KURZ
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP6													  
; rcall LCD_AUSGABE_ZAHL_9_STELLEN_KURZ	; INP: TEMP1...					  
LCD_AUSGABE_ZAHL_9_STELLEN_KURZ:
	mov temp, temp9			; 9.ZEICHEN 
	rcall LCD_DATA_TEMP
LCD_AUSGABE_ZAHL_8_STELLEN_KURZ:
	mov temp, temp8			; 8.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_AUSGABE_ZAHL_7_STELLEN_KURZ:
	mov temp, temp7			; 7.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_AUSGABE_ZAHL_6_STELLEN_KURZ:
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_AUSGABE_ZAHL_5_STELLEN_KURZ:
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_AUSGABE_ZAHL_4_STELLEN_KURZ:
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_AUSGABE_ZAHL_3_STELLEN_KURZ:
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_AUSGABE_ZAHL_2_STELLEN_KURZ:
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA_TEMP	
LCD_AUSGABE_ZAHL_1_STELLEN_KURZ:
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rjmp  LCD_DATA_TEMP
;######################################################################## 	
;######################################################################## 	
;######################################################################## 	
; formatiert die LCD AUSGABE mit 1000-er Punkt								
; 	Bsp. "00012345 => "___12.345"											
;	INPUT/Output TEMP1														
;	INPUT/Output TEMP2														
;	INPUT/Output TEMP3														
;	INPUT/Output TEMP4														
;	INPUT/Output TEMP5														
;	INPUT/Output TEMP6														
; 	INPUT/Output TEMP8														
; 	      Output TEMP9														
LCD_FORMAT:
;   1000-er Trennzeichen einfgen	
	mov temp9,temp7
	ldi temp8,'.'
	mov temp7,temp6
	mov temp6,temp5
	mov temp5,temp4
	ldi temp4,'.'
; Nullstellen-Unterdrckung			
	cpi temp9, '0'
	brne LCD_FORMAT_fertig
	ldi temp9, '_'
	ldi temp8, '_'
	cpi temp7, '0'
	brne LCD_FORMAT_fertig
	ldi temp7, '_'
	cpi temp6, '0'
	brne LCD_FORMAT_fertig
	ldi temp6, '_'
	cpi temp5, '0'
	brne LCD_FORMAT_fertig
	ldi temp5, '_'
	ldi temp4, '_'
	cpi temp3, '0'
	brne LCD_FORMAT_fertig
	ldi temp3, '_'
	cpi temp2, '0'
	brne LCD_FORMAT_fertig
	ldi temp2, '_'
	cpi temp1, '0'
	brne LCD_FORMAT_fertig
	ldi temp1, '_'
LCD_FORMAT_fertig:
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Initialisierung: muss ganz am Anfang des Programms aufgerufen werden
LCD_INITIALISIERUNG:
 
	; auf LOW				
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
	cbi (LCD_E_PORT),(LCD_E)
	cbi (LCD_RS_PORT),(LCD_RS)
	; auf Ausgang			
	sbi (LCD_DATA0_DDR),(LCD_DATA0)
	sbi (LCD_DATA1_DDR),(LCD_DATA1)
	sbi (LCD_DATA2_DDR),(LCD_DATA2)
	sbi (LCD_DATA3_DDR),(LCD_DATA3)
	sbi (LCD_RS_DDR),(LCD_RS)
	sbi (LCD_E_DDR),(LCD_E)
	; INITIALISIERUNG		
    cbi (LCD_RS_PORT),(LCD_RS) 			; RS aus (low)				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)  	; x03 muss 3mal hintereinander gesendet werden zur Initialisierun
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	rcall LCD_ENABLE					; 1	
	rcall LCD_ENABLE					; 2	
	rcall LCD_ENABLE					; 3	
    ldi temp, 0b00000010        ;4bit-Modus einstellen
	rcall LCD_COMMAND
    ldi temp, 0b00000001        ; DISPLAY lschen			
 	rcall LCD_COMMAND
    ldi temp, 0b00001111        ; DISPLAY ein / CURSOR blinken	
    ldi temp, 0b00001100 		; CURSOR aus					
	rcall LCD_COMMAND
    ldi temp, 0b00000110        ; Cursor Auto-Increment
 	rcall LCD_COMMAND

ret
;######################################################################## 
;######################################################################## 
;																		  
;erzeugt den Enable-Puls												  
;																		  
LCD_ENABLE:
	sbi (LCD_E_PORT),(LCD_E)         	; Enable high		
   	rcall wait_50us                   	; kurze PAUSE		
	cbi (LCD_E_PORT),(LCD_E)            ; Enable low		
	rjmp  wait_50us                   	; kurze PAUSE		
;######################################################################## 
;######################################################################## 
;######################################################################## 
; sendet ein Datenbyte an das LCD										  
;																		  
; INPUT: temp															  
;																		  
; rcall LCD_DATA			; DATENBYTE an LCD inp: temp 				  
;																		  
LCD_DATA_TEMP:
	sbi LCD_RS_PORT, LCD_RS 			; RS ein/auf DATA (high)				
LCD_DATA_RS:
	cbi (LCD_DATA0_PORT),(LCD_DATA0)	; alle auf LOW							
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,4							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,5
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,6
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,7
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall lcd_enable        			; Enable-Routine aufrufen				
;-------------------------------------------------------------------------------
	cbi (LCD_DATA0_PORT),(LCD_DATA0)	; auf LOW								
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,0							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,1
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,2
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,3
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall lcd_enable        			; Enable-Routine aufrufen				
	rcall wait_5us						; Pause 								
	sbi LCD_RS_PORT, LCD_RS 			; vorsichtshalber RS ein/auf DATA (high)
ret				                       
;######################################################################## 
;######################################################################## 
;######################################################################## 
;																		  
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  
;																		  
; INPUT: temp															  
;																		  
LCD_COMMAND:                            
    cbi (LCD_RS_PORT),(LCD_RS) 			;	 RS aus (low)				
	rcall LCD_DATA_RS
	rcall wait_5ms						; Pause (wichtig)				
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; eine Text anzeigen INP: Z													
ANZEIGE_TEXT:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq ANZEIGE_TEXT_e 	; Sprung
	rcall LCD_DATA_TEMP		; Anzeige
	rjmp ANZEIGE_TEXT
	ANZEIGE_TEXT_e:
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; Display lschen														  
LCD_CLEAR:
   	ldi temp, 0b00000001
    rcall lcd_command
ret
;######################################################################## 
; KURSOR Sprung in ZEILE!												  
LCD_ZEILE1:
 	ldi temp, 0b00000010
	rcall lcd_command 
ret
;######################################################################## 
; KURSOR Sprung in ZEILE2												  
LCD_ZEILE2:
 	ldi temp, 0b11000000 
	rcall lcd_command 
ret
;######################################################################## 
; KURSOR Sprung in ZEILE3												  
LCD_ZEILE3:
	ldi temp, 0b10010100
	rcall lcd_command 
ret
;######################################################################## 
; KURSOR Sprung in ZEILE4												  
LCD_ZEILE4:
	ldi temp, 0b11010100
	rcall lcd_command 
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
LCD_SPACE10:
	rcall LCD_SPACE
LCD_SPACE9:
	rcall LCD_SPACE
LCD_SPACE8:
	rcall LCD_SPACE
LCD_SPACE7:
	rcall LCD_SPACE
LCD_SPACE6:
	rcall LCD_SPACE
LCD_SPACE5:
	rcall LCD_SPACE
LCD_SPACE4:
	rcall LCD_SPACE
LCD_SPACE3:
	rcall LCD_SPACE
LCD_SPACE2:
	rcall LCD_SPACE
	rcall LCD_SPACE
ret
;-------------------------------------------------------------------------
LCD_SPACE:
	ldi temp, ' '		; SPACE
	rcall LCD_DATA_TEMP	
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
LCD_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA_TEMP	
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
LCD_DOPPEL_PUNKT:
	ldi temp, ':'		; DOPPELPUNKT
	rcall LCD_DATA_TEMP	
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
LCD_STERN:
	ldi temp, '*'		; STERN
	rcall LCD_DATA_TEMP	
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INP: temp1																
; OUT: (z.B."FF") 															
;																			
; rcall ANZEIGE_HEX_TEMP1 ; inp: temp1										
;																			
ANZEIGE_HEX_TEMP1:
	; SICHERUNGSKOPIE						
	push temp
	push temp1
	; oberes NIBBLE bearbeiten				
	mov temp,temp1	
	swap temp						; NIBBLES tausch	
	rcall ANZEIGE_HEX_UMWANDLUNG	; INP/OUT: temp		
	rcall LCD_DATA_TEMP				; ANZEIGE			
	; unteres NIBBLE bearbeiten				
	mov temp,temp1	
	rcall ANZEIGE_HEX_UMWANDLUNG	; INP/OUT: temp		
	rcall LCD_DATA_TEMP				; ANZEIGE			
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp1
	pop temp
	ret
;-------------------------------------------------------------------------------
ANZEIGE_HEX_UMWANDLUNG:
	; BITMUSTER	
	andi temp,0b00001111
	; vergleich	
	cpi temp,10
	brsh ANZEIGE_HEX_UMWANDLUNG_A_F
ANZEIGE_HEX_UMWANDLUNG_0_9:
	subi temp,-48
	ret
ANZEIGE_HEX_UMWANDLUNG_A_F:
	subi temp,-48-7
	ret
;######################################################################## 
;########################################################################
;######################################################################## 
